diff --git a/drivers/mtd/spi/sf_internal.h b/drivers/mtd/spi/sf_internal.h
index 14b8b55..9341fb3 100644
--- a/drivers/mtd/spi/sf_internal.h
+++ b/drivers/mtd/spi/sf_internal.h
@@ -171,13 +171,13 @@ int spi_flash_cmd_write(struct spi_slave *spi, const u8 *cmd, size_t cmd_len,
 int spi_flash_cmd_erase_ops(struct spi_flash *flash, u32 offset, size_t len);
 
 /* Read the status register */
-int spi_flash_cmd_read_status(struct spi_flash *flash, u8 *rs);
+int spi_flash_cmd_read_status(struct spi_flash *flash);
 
 /* Program the status register */
 int spi_flash_cmd_write_status(struct spi_flash *flash, u8 ws);
 
 /* Read the config register */
-int spi_flash_cmd_read_config(struct spi_flash *flash, u8 *rc);
+int spi_flash_cmd_read_config(struct spi_flash *flash);
 
 /* Program the config register */
 int spi_flash_cmd_write_config(struct spi_flash *flash, u8 wc);
diff --git a/drivers/mtd/spi/sf_ops.c b/drivers/mtd/spi/sf_ops.c
index 85e15b9..4c807ed 100644
--- a/drivers/mtd/spi/sf_ops.c
+++ b/drivers/mtd/spi/sf_ops.c
@@ -26,34 +26,32 @@ static void spi_flash_addr(u32 addr, u8 *cmd)
 	cmd[3] = addr >> 0;
 }
 
-int spi_flash_cmd_read_status(struct spi_flash *flash, u8 *rs)
+int spi_flash_cmd_read_status(struct spi_flash *flash)
 {
 	int ret;
-	u8 cmd;
+	u8 rs;
 
-	cmd = CMD_READ_STATUS;
-	ret = spi_flash_read_common(flash, &cmd, 1, rs, 1);
+	ret = flash_read_reg(flash, CMD_READ_STATUS, &rs, 1);
 	if (ret < 0) {
 		debug("SF: fail to read status register\n");
 		return ret;
 	}
 
-	return 0;
+	return rs;
 }
 
-static int read_fsr(struct spi_flash *flash, u8 *fsr)
+static int read_fsr(struct spi_flash *flash)
 {
 	int ret;
-	u8 cmd;
+	u8 fsr;
 
-	cmd = CMD_FLAG_STATUS;
-	ret = spi_flash_read_common(flash, &cmd, 1, fsr, 1);
+	ret = flash_read_reg(flash, CMD_FLAG_STATUS, &fsr, 1);
 	if (ret < 0) {
 		debug("SF: fail to read flag status register\n");
 		return ret;
 	}
 
-	return 0;
+	return fsr;
 }
 
 int spi_flash_cmd_write_status(struct spi_flash *flash, u8 ws)
@@ -72,30 +70,31 @@ int spi_flash_cmd_write_status(struct spi_flash *flash, u8 ws)
 }
 
 #if defined(CONFIG_SPI_FLASH_SPANSION) || defined(CONFIG_SPI_FLASH_WINBOND)
-int spi_flash_cmd_read_config(struct spi_flash *flash, u8 *rc)
+int spi_flash_cmd_read_config(struct spi_flash *flash)
 {
 	int ret;
-	u8 cmd;
+	u8 rc;
 
-	cmd = CMD_READ_CONFIG;
-	ret = spi_flash_read_common(flash, &cmd, 1, rc, 1);
+	ret = flash_read_reg(flash, CMD_READ_CONFIG, &rc, 1);
 	if (ret < 0) {
 		debug("SF: fail to read config register\n");
 		return ret;
 	}
 
-	return 0;
+	return rc;
 }
 
 int spi_flash_cmd_write_config(struct spi_flash *flash, u8 wc)
 {
 	u8 data[2];
 	u8 cmd;
-	int ret;
+	int ret, val;
 
-	ret = spi_flash_cmd_read_status(flash, &data[0]);
-	if (ret < 0)
-		return ret;
+	val = spi_flash_cmd_read_status(flash);
+	if (val < 0)
+		return val;
+
+	data[0] = val;
 
 	cmd = CMD_WRITE_STATUS;
 	data[1] = wc;
@@ -156,26 +155,20 @@ static void spi_flash_dual_flash(struct spi_flash *flash, u32 *addr)
 
 static inline int spi_flash_sr_ready(struct spi_flash *flash)
 {
-	u8 sr;
-	int ret;
-
-	ret = spi_flash_cmd_read_status(flash, &sr);
-	if (ret < 0)
-		return ret;
-
-	return !(sr & STATUS_WIP);
+	int sr = spi_flash_cmd_read_status(flash);
+	if (sr < 0)
+		return sr;
+	else
+		return !(sr & STATUS_WIP);
 }
 
 static inline int spi_flash_fsr_ready(struct spi_flash *flash)
 {
-	u8 fsr;
-	int ret;
-
-	ret = read_fsr(flash, &fsr);
-	if (ret < 0)
-		return ret;
-
-	return fsr & STATUS_PEC;
+	int fsr = read_fsr(flash);
+	if (fsr < 0)
+		return fsr;
+	else
+		return fsr & STATUS_PEC;
 }
 
 static int spi_flash_ready(struct spi_flash *flash)
diff --git a/drivers/mtd/spi/sf_probe.c b/drivers/mtd/spi/sf_probe.c
index 758347b..262849e 100644
--- a/drivers/mtd/spi/sf_probe.c
+++ b/drivers/mtd/spi/sf_probe.c
@@ -35,12 +35,11 @@ static u8 spi_read_cmds_array[] = {
 #ifdef CONFIG_SPI_FLASH_MACRONIX
 static int spi_flash_set_qeb_mxic(struct spi_flash *flash)
 {
-	u8 qeb_status;
-	int ret;
+	int qeb_status, ret;
 
-	ret = spi_flash_cmd_read_status(flash, &qeb_status);
-	if (ret < 0)
-		return ret;
+	qeb_status = spi_flash_cmd_read_config(flash);
+	if (qeb_status < 0)
+		return qeb_status;
 
 	if (qeb_status & STATUS_QEB_MXIC) {
 		debug("SF: mxic: QEB is already set\n");
@@ -57,12 +56,11 @@ static int spi_flash_set_qeb_mxic(struct spi_flash *flash)
 #if defined(CONFIG_SPI_FLASH_SPANSION) || defined(CONFIG_SPI_FLASH_WINBOND)
 static int spi_flash_set_qeb_winspan(struct spi_flash *flash)
 {
-	u8 qeb_status;
-	int ret;
+	int qeb_status, ret;
 
-	ret = spi_flash_cmd_read_config(flash, &qeb_status);
-	if (ret < 0)
-		return ret;
+	qeb_status = spi_flash_cmd_read_config(flash);
+	if (qeb_status < 0)
+		return qeb_status;
 
 	if (qeb_status & STATUS_QEB_WINSPAN) {
 		debug("SF: winspan: QEB is already set\n");
@@ -117,8 +115,7 @@ static int spi_flash_read_bank(struct spi_flash *flash, u8 idcode0)
 		flash->bank_write_cmd = CMD_EXTNADDR_WREAR;
 	}
 
-	ret = spi_flash_read_common(flash, &flash->bank_read_cmd, 1,
-				    &curr_bank, 1);
+	ret = flash_read_reg(flash, flash->bank_read_cmd, &curr_bank, 1);
 	if (ret) {
 		debug("SF: fail to read bank addr register\n");
 		return ret;